package com.landray.kmss.sys.attachment.integrate.wps.util;

import java.io.InputStream;
import com.landray.kmss.sys.filestore.scheduler.third.wps.WpsUtil;
import java.util.HashMap;
import com.landray.kmss.sys.attachment.util.SysAttConfigUtil;
import com.landray.kmss.sys.attachment.model.SysAttMain;
import java.util.List;
import javax.servlet.http.HttpServletRequest;
import net.sf.json.JSONObject;
import java.util.Map;
import com.landray.kmss.util.StringUtil;
import com.landray.kmss.sys.appconfig.model.BaseAppconfigCache;
import com.landray.kmss.util.UserUtil;
import com.landray.kmss.util.SpringBeanUtil;
import com.landray.kmss.sys.attachment.integrate.wps.interfaces.ISysAttachmentWpsCenterOfficeProvider;

public class SysAttWpsCenterUtil
{
    public static void saveWpsToken(final String wpsToken) throws Exception {
        final ISysAttachmentWpsCenterOfficeProvider wpsCenterProvider = (ISysAttachmentWpsCenterOfficeProvider)SpringBeanUtil.getBean("wpsCenterProvider");
        if (wpsCenterProvider != null) {
            wpsCenterProvider.saveWpsToken(wpsToken);
        }
    }
    
    public static String getWpsToken() throws Exception {
        final ISysAttachmentWpsCenterOfficeProvider wpsCenterProvider = (ISysAttachmentWpsCenterOfficeProvider)SpringBeanUtil.getBean("wpsCenterProvider");
        if (wpsCenterProvider != null) {
            return wpsCenterProvider.getWpsToken();
        }
        return null;
    }
    
    public static String getLongCallBackToken() throws Exception {
        final ISysAttachmentWpsCenterOfficeProvider wpsCenterProvider = (ISysAttachmentWpsCenterOfficeProvider)SpringBeanUtil.getBean("wpsCenterProvider");
        if (wpsCenterProvider != null) {
            return wpsCenterProvider.getLongCallBackToken(UserUtil.getUser().getFdId(), getWpsToken(), Boolean.valueOf(true));
        }
        return null;
    }
    
    public static Long getShortTokenTimeOut() {
        Long timeOut = 300000L;
        final Map<String, String> dataMap = BaseAppconfigCache.getCacheData("com.landray.kmss.third.wps.model.ThirdWpsConfig");
        if (!dataMap.isEmpty() && StringUtil.isNotNull((String)dataMap.get("thirdWpsShortTokenTimeOut"))) {
            timeOut = Integer.valueOf(dataMap.get("thirdWpsShortTokenTimeOut")) * 60L * 1000L;
        }
        return timeOut;
    }
    
    public static Long getLongTokenTimeOut() {
        Long timeOut = 3600000L;
        final Map<String, String> dataMap = BaseAppconfigCache.getCacheData("com.landray.kmss.third.wps.model.ThirdWpsConfig");
        if (!dataMap.isEmpty() && StringUtil.isNotNull((String)dataMap.get("thirdWpsLongTokenTimeOut"))) {
            timeOut = Integer.valueOf(dataMap.get("thirdWpsLongTokenTimeOut")) * 60L * 1000L;
        }
        return timeOut;
    }
    
    public static void setSingure(final Map<String, String> header, final String shaUrl, final Map parameter) throws Exception {
        final ISysAttachmentWpsCenterOfficeProvider wpsCenterProvider = (ISysAttachmentWpsCenterOfficeProvider)SpringBeanUtil.getBean("wpsCenterProvider");
        if (wpsCenterProvider != null) {
            wpsCenterProvider.setSingure((Map)header, shaUrl, parameter);
        }
    }
    
    public static JSONObject getWpsCenterViewAndEditUrl(final String fdAttMainId, final String fdMode) throws Exception {
        final ISysAttachmentWpsCenterOfficeProvider wpsCenterProvider = (ISysAttachmentWpsCenterOfficeProvider)SpringBeanUtil.getBean("wpsCenterProvider");
        if (wpsCenterProvider != null) {
            return wpsCenterProvider.getWpsCenterViewAndEditUrl(fdAttMainId, fdMode);
        }
        return null;
    }
    
    public static JSONObject getWpsCenterEditUrl(final HttpServletRequest request) throws Exception {
        final ISysAttachmentWpsCenterOfficeProvider wpsCenterProvider = (ISysAttachmentWpsCenterOfficeProvider)SpringBeanUtil.getBean("wpsCenterProvider");
        if (wpsCenterProvider != null) {
            return wpsCenterProvider.getWpsCenterEditUrl(request);
        }
        return null;
    }
    
    public static String wpsCenterWrapHeader(final List<Map<String, Object>> fileInfos, final List<Map<String, Object>> fillDatas, final String fdModelId, final String fdModelName, final String fdAttMainId, final String type, final String userId) throws Exception {
        final ISysAttachmentWpsCenterOfficeProvider wpsCenterProvider = (ISysAttachmentWpsCenterOfficeProvider)SpringBeanUtil.getBean("wpsCenterProvider");
        if (wpsCenterProvider != null) {
            return wpsCenterProvider.wpsCenterWrapHeader((List)fileInfos, (List)fillDatas, fdModelId, fdModelName, fdAttMainId, type, userId);
        }
        return null;
    }
    
    public static String wpsCenterOperateClean(final SysAttMain sysAttMain, final String userId, final String type) throws Exception {
        final ISysAttachmentWpsCenterOfficeProvider wpsCenterProvider = (ISysAttachmentWpsCenterOfficeProvider)SpringBeanUtil.getBean("wpsCenterProvider");
        if (wpsCenterProvider != null) {
            return wpsCenterProvider.wpsCenterOperateClean(sysAttMain, userId, type);
        }
        return null;
    }
    
    public static JSONObject getWpsCenterPreviewUrl(final String fdAttMainId, final String fdMode) throws Exception {
        final ISysAttachmentWpsCenterOfficeProvider wpsCenterProvider = (ISysAttachmentWpsCenterOfficeProvider)SpringBeanUtil.getBean("wpsCenterProvider");
        if (wpsCenterProvider != null) {
            return wpsCenterProvider.getWpsCenterPreviewUrl(fdAttMainId, fdMode);
        }
        return null;
    }
    
    public static boolean isWpsCenterSfs() {
        final Map<String, String> dataMap = BaseAppconfigCache.getCacheData("com.landray.kmss.third.wps.model.ThirdWpsConfig");
        return "true".equals(dataMap.get("thirdWpsCenterEnabled")) && "true".equals(dataMap.get("wpsCenterSfs"));
    }
    
    public static String getWpsCenterV6Sdk() {
        if (!SysAttConfigUtil.isWpsCenterV6Enabled()) {
            return null;
        }
        final HashMap<String, String> map = new HashMap<String, String>(BaseAppconfigCache.getCacheData("com.landray.kmss.third.wps.model.ThirdWpsCenterV6Config"));
        if (map == null) {
            return null;
        }
        return map.get("sdkVersion");
    }
    
    public static Boolean isEnable() throws Exception {
        Boolean flag = false;
        if ("4".equals(SysAttConfigUtil.getOnlineToolType()) && "true".equals(WpsUtil.configInfo("thirdWpsCenterEnabled"))) {
            flag = true;
        }
        return flag;
    }
    
    public static Boolean isV6View() {
        try {
            final String readOLConfig = SysAttConfigUtil.getReadOLConfig();
            final boolean enabled = SysAttConfigUtil.isWpsCenterV6Enabled();
            if ("8".equals(readOLConfig) && enabled) {
                return true;
            }
            return false;
        }
        catch (final Exception ex) {
            return false;
        }
    }
    
    public static Boolean isV6Edit() {
        try {
            final String onlineToolType = SysAttConfigUtil.getOnlineToolType();
            final boolean enabled = SysAttConfigUtil.isWpsCenterV6Enabled();
            if ("6".equals(onlineToolType) && enabled) {
                return true;
            }
            return false;
        }
        catch (final Exception ex) {
            return false;
        }
    }
    
    public static Boolean isWPSCenterEnableMobile(final boolean isMobile) throws Exception {
        Boolean wpsCenter = false;
        if (isMobile && "0".equals(SysAttConfigUtil.getOnlineToolType()) && ("4".equals(SysAttConfigUtil.isReadJGForMobile()) || "6".equals(SysAttConfigUtil.isReadJGForMobile()))) {
            wpsCenter = true;
        }
        else if (isMobile && "3".equals(SysAttConfigUtil.getOnlineToolType()) && ("4".equals(SysAttConfigUtil.isReadJGForMobile()) || "6".equals(SysAttConfigUtil.isReadJGForMobile()))) {
            wpsCenter = true;
        }
        else if (isMobile && "4".equals(SysAttConfigUtil.getOnlineToolType()) && "4".equals(SysAttConfigUtil.isReadWPSCenterForMobile())) {
            wpsCenter = true;
        }
        else if (isMobile && "6".equals(SysAttConfigUtil.getOnlineToolType()) && "6".equals(SysAttConfigUtil.isReadWPSCenterV6ForMobile())) {
            wpsCenter = true;
        }
        else if (isMobile && "1".equals(SysAttConfigUtil.getOnlineToolType()) && ("4".equals(SysAttConfigUtil.isReadJGForMobile()) || "6".equals(SysAttConfigUtil.isReadJGForMobile()))) {
            wpsCenter = true;
        }
        return wpsCenter;
    }
    
    public static JSONObject getCovertDownload(final String taskID) throws Exception {
        final ISysAttachmentWpsCenterOfficeProvider wpsCenterProvider = (ISysAttachmentWpsCenterOfficeProvider)SpringBeanUtil.getBean("wpsCenterProvider");
        if (wpsCenterProvider != null) {
            return wpsCenterProvider.getCovertDownload(taskID);
        }
        return null;
    }
    
    public static JSONObject getCovertDownload(final String fdModelId, final String fdModelName, final String type) throws Exception {
        final ISysAttachmentWpsCenterOfficeProvider wpsCenterProvider = (ISysAttachmentWpsCenterOfficeProvider)SpringBeanUtil.getBean("wpsCenterProvider");
        if (wpsCenterProvider != null) {
            return wpsCenterProvider.getCovertDownload(fdModelId, fdModelName, type);
        }
        return null;
    }
    
    public static InputStream downloadByTaskId(final String taskId) throws Exception {
        final ISysAttachmentWpsCenterOfficeProvider wpsCenterProvider = (ISysAttachmentWpsCenterOfficeProvider)SpringBeanUtil.getBean("wpsCenterProvider");
        if (wpsCenterProvider != null) {
            return wpsCenterProvider.downloadByTaskId(taskId);
        }
        return null;
    }
    
    public static String downloadUrlByTaskId(final String taskId) throws Exception {
        final ISysAttachmentWpsCenterOfficeProvider wpsCenterProvider = (ISysAttachmentWpsCenterOfficeProvider)SpringBeanUtil.getBean("wpsCenterProvider");
        if (wpsCenterProvider != null) {
            return wpsCenterProvider.downloadUrlByTaskId(taskId);
        }
        return null;
    }
    
    public static InputStream downloadByUrl(final String wpsUrl) throws Exception {
        final ISysAttachmentWpsCenterOfficeProvider wpsCenterProvider = (ISysAttachmentWpsCenterOfficeProvider)SpringBeanUtil.getBean("wpsCenterProvider");
        if (wpsCenterProvider != null) {
            return wpsCenterProvider.downloadWithUrl(wpsUrl);
        }
        return null;
    }
    
    public static String getWpsDownloadUrl(final String fdAttMainId, final String userId) throws Exception {
        final ISysAttachmentWpsCenterOfficeProvider wpsCenterProvider = (ISysAttachmentWpsCenterOfficeProvider)SpringBeanUtil.getBean("wpsCenterProvider");
        if (wpsCenterProvider != null) {
            return wpsCenterProvider.generateDownloadUrl(fdAttMainId, userId);
        }
        return null;
    }
    
    public static void updateAuthExpiredTodo() {
        final ISysAttachmentWpsCenterOfficeProvider wpsCenterProvider = (ISysAttachmentWpsCenterOfficeProvider)SpringBeanUtil.getBean("wpsCenterProvider");
        if (wpsCenterProvider != null) {
            wpsCenterProvider.updateAuthExpiredTodo();
        }
    }
    
    public static String getWpsUrl() {
        final ISysAttachmentWpsCenterOfficeProvider wpsCenterProvider = (ISysAttachmentWpsCenterOfficeProvider)SpringBeanUtil.getBean("wpsCenterProvider");
        if (wpsCenterProvider != null) {
            try {
                return wpsCenterProvider.getWpsUrl();
            }
            catch (final Exception e) {
                e.printStackTrace();
            }
        }
        return "";
    }
    
    public static Boolean isWpsCenter() throws Exception {
        Boolean flag = false;
        if ("4".equals(SysAttConfigUtil.getOnlineToolType()) && "true".equals(WpsUtil.configInfo("thirdWpsCenterEnabled"))) {
            flag = true;
        }
        else if ("6".equals(SysAttConfigUtil.getOnlineToolType()) && SysAttConfigUtil.isWpsCenterV6Enabled()) {
            flag = true;
        }
        return flag;
    }
}
